blob: 32e573943cf036bda7d45082779917676b7a05fe [file] [log] [blame]
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +02001#!/bin/sh
Greg Kroah-Hartmanb2441312017-11-01 15:07:57 +01002# SPDX-License-Identifier: GPL-2.0
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +02003#
4# link vmlinux
5#
Masahiro Yamada32164842022-09-25 03:19:14 +09006# vmlinux is linked from the objects in vmlinux.a and $(KBUILD_VMLINUX_LIBS).
7# vmlinux.a contains objects that are linked unconditionally.
Masahiro Yamadad151e972019-01-17 09:10:04 +09008# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
9# (not within --whole-archive), and do not require symbol indexes added.
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020010#
11# vmlinux
12# ^
13# |
Masahiro Yamada32164842022-09-25 03:19:14 +090014# +--< vmlinux.a
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020015# |
Nicholas Piggin3a166fc2017-06-20 01:52:05 +100016# +--< $(KBUILD_VMLINUX_LIBS)
17# | +--< lib/lib.a + more
18# |
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020019# +-< ${kallsymso} (see description in KALLSYMS section)
20#
21# vmlinux version (uname -v) cannot be updated during normal
22# descending-into-subdirs phase since we do not yet know if we need to
23# update vmlinux.
24# Therefore this step is delayed until just before final link of vmlinux.
25#
26# System.map is generated to document addresses of all kernel symbols
27
28# Error out on error
29set -e
30
Masahiro Yamada3ec8a5b2020-07-02 04:29:36 +090031LD="$1"
32KBUILD_LDFLAGS="$2"
33LDFLAGS_vmlinux="$3"
34
Masahiro Yamada7d153692021-12-14 11:53:52 +090035is_enabled() {
36 grep -q "^$1=y" include/config/auto.conf
37}
38
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020039# Nice output in kbuild format
40# Will be supressed by "make -s"
41info()
42{
Masahiro Yamadac39013e2021-05-17 16:03:14 +090043 printf " %-7s %s\n" "${1}" "${2}"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020044}
45
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020046# Link of vmlinux
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -070047# ${1} - output file
Andrii Nakryiko618916a2019-09-05 10:59:38 -070048# ${2}, ${3}, ... - optional extra .o files
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020049vmlinux_link()
50{
Andrii Nakryiko618916a2019-09-05 10:59:38 -070051 local output=${1}
Masahiro Yamada8f130512021-08-19 09:57:37 +090052 local objs
53 local libs
Masahiro Yamada5df77ad2021-08-19 09:57:39 +090054 local ld
55 local ldflags
56 local ldlibs
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020057
Linus Torvaldsd7b08272019-09-20 08:36:47 -070058 info LD ${output}
59
Andrii Nakryiko618916a2019-09-05 10:59:38 -070060 # skip output file argument
61 shift
62
Peter Zijlstraed53a0d2022-03-08 16:30:56 +010063 if is_enabled CONFIG_LTO_CLANG || is_enabled CONFIG_X86_KERNEL_IBT; then
Masahiro Yamada8f130512021-08-19 09:57:37 +090064 # Use vmlinux.o instead of performing the slow LTO link again.
65 objs=vmlinux.o
66 libs=
67 else
Masahiro Yamada32164842022-09-25 03:19:14 +090068 objs=vmlinux.a
Masahiro Yamada8f130512021-08-19 09:57:37 +090069 libs="${KBUILD_VMLINUX_LIBS}"
70 fi
71
Masahiro Yamada7b453712022-05-13 20:39:22 +090072 if is_enabled CONFIG_MODULES; then
73 objs="${objs} .vmlinux.export.o"
74 fi
75
Masahiro Yamada2df8220c2022-08-28 11:39:53 +090076 objs="${objs} init/version-timestamp.o"
77
Masahiro Yamada5df77ad2021-08-19 09:57:39 +090078 if [ "${SRCARCH}" = "um" ]; then
79 wl=-Wl,
80 ld="${CC}"
81 ldflags="${CFLAGS_vmlinux}"
82 ldlibs="-lutil -lrt -lpthread"
83 else
84 wl=
85 ld="${LD}"
86 ldflags="${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux}"
87 ldlibs=
88 fi
89
90 ldflags="${ldflags} ${wl}--script=${objtree}/${KBUILD_LDS}"
91
Kees Cookaf73d782020-03-03 18:18:34 -080092 # The kallsyms linking does not need debug symbols included.
93 if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then
Masahiro Yamada5df77ad2021-08-19 09:57:39 +090094 ldflags="${ldflags} ${wl}--strip-debug"
Kees Cookaf73d782020-03-03 18:18:34 -080095 fi
96
Masahiro Yamada7d153692021-12-14 11:53:52 +090097 if is_enabled CONFIG_VMLINUX_MAP; then
Masahiro Yamada5df77ad2021-08-19 09:57:39 +090098 ldflags="${ldflags} ${wl}-Map=${output}.map"
Rasmus Villemoes5cc12472021-03-05 10:27:07 +010099 fi
100
Masahiro Yamada5df77ad2021-08-19 09:57:39 +0900101 ${ld} ${ldflags} -o ${output} \
102 ${wl}--whole-archive ${objs} ${wl}--no-whole-archive \
103 ${wl}--start-group ${libs} ${wl}--end-group \
104 $@ ${ldlibs}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200105}
106
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700107# generate .BTF typeinfo from DWARF debuginfo
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700108# ${1} - vmlinux image
109# ${2} - file to dump raw BTF data into
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700110gen_btf()
111{
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700112 local pahole_ver
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700113
Andrii Nakryiko581b31c2019-05-05 17:10:33 -0700114 if ! [ -x "$(command -v ${PAHOLE})" ]; then
Chris Down2a67a6c2020-01-22 00:01:10 +0000115 echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700116 return 1
Andrii Nakryiko581b31c2019-05-05 17:10:33 -0700117 fi
118
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700119 pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
Lorenz Bauer21a85bd2020-06-08 10:42:57 +0100120 if [ "${pahole_ver}" -lt "116" ]; then
121 echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.16"
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700122 return 1
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700123 fi
124
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700125 vmlinux_link ${1}
Kees Cookaf73d782020-03-03 18:18:34 -0800126
127 info "BTF" ${2}
Jiri Olsa9741e072021-10-29 14:57:29 +0200128 LLVM_OBJCOPY="${OBJCOPY}" ${PAHOLE} -J ${PAHOLE_FLAGS} ${1}
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700129
Fangrui Song90ceddc2020-03-18 15:27:46 -0700130 # Create ${2} which contains just .BTF section but no symbols. Add
131 # SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
132 # deletes all symbols including __start_BTF and __stop_BTF, which will
133 # be redefined in the linker script. Add 2>/dev/null to suppress GNU
134 # objcopy warnings: "empty loadable segment detected at ..."
135 ${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
136 --strip-all ${1} ${2} 2>/dev/null
137 # Change e_type to ET_REL so that it can be used to link final vmlinux.
138 # Unlike GNU ld, lld does not allow an ET_EXEC input.
139 printf '\1' | dd of=${2} conv=notrunc bs=1 seek=16 status=none
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700140}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200141
Masahiro Yamada08beb662020-09-25 00:45:46 +0900142# Create ${2} .S file with all symbols from the ${1} object file
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200143kallsyms()
144{
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200145 local kallsymopt;
146
Masahiro Yamada7d153692021-12-14 11:53:52 +0900147 if is_enabled CONFIG_KALLSYMS_ALL; then
James Hogan6895f972012-09-06 22:11:25 +0100148 kallsymopt="${kallsymopt} --all-symbols"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200149 fi
150
Masahiro Yamada7d153692021-12-14 11:53:52 +0900151 if is_enabled CONFIG_KALLSYMS_ABSOLUTE_PERCPU; then
Rusty Russellc6bda7c2014-03-17 14:05:46 +1030152 kallsymopt="${kallsymopt} --absolute-percpu"
153 fi
154
Masahiro Yamada7d153692021-12-14 11:53:52 +0900155 if is_enabled CONFIG_KALLSYMS_BASE_RELATIVE; then
Ard Biesheuvel2213e9a2016-03-15 14:58:19 -0700156 kallsymopt="${kallsymopt} --base-relative"
157 fi
158
Zhen Lei010a0aa2022-11-02 16:49:15 +0800159 if is_enabled CONFIG_LTO_CLANG; then
160 kallsymopt="${kallsymopt} --lto-clang"
161 fi
162
Masahiro Yamada08beb662020-09-25 00:45:46 +0900163 info KSYMS ${2}
Masahiro Yamadaaa221f22022-09-26 18:02:28 +0900164 scripts/kallsyms ${kallsymopt} ${1} > ${2}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200165}
166
Kees Cook8959e392019-08-13 08:15:32 -0700167# Perform one step in kallsyms generation, including temporary linking of
168# vmlinux.
169kallsyms_step()
170{
171 kallsymso_prev=${kallsymso}
Kees Cookaf73d782020-03-03 18:18:34 -0800172 kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1}
173 kallsymso=${kallsyms_vmlinux}.o
Masahiro Yamada08beb662020-09-25 00:45:46 +0900174 kallsyms_S=${kallsyms_vmlinux}.S
Kees Cook8959e392019-08-13 08:15:32 -0700175
Linus Torvaldsd7b08272019-09-20 08:36:47 -0700176 vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
Masahiro Yamada94ff2f62022-09-26 18:02:26 +0900177 mksysmap ${kallsyms_vmlinux} ${kallsyms_vmlinux}.syms
178 kallsyms ${kallsyms_vmlinux}.syms ${kallsyms_S}
Masahiro Yamada08beb662020-09-25 00:45:46 +0900179
180 info AS ${kallsyms_S}
181 ${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS} \
182 ${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
183 -c -o ${kallsymso} ${kallsyms_S}
Kees Cook8959e392019-08-13 08:15:32 -0700184}
185
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200186# Create map file with all symbols from ${1}
187# See mksymap for additional details
188mksysmap()
189{
Masahiro Yamada94ff2f62022-09-26 18:02:26 +0900190 info NM ${2}
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200191 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
192}
193
Shile Zhang10916702019-12-04 08:46:31 +0800194sorttable()
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700195{
Shile Zhang10916702019-12-04 08:46:31 +0800196 ${objtree}/scripts/sorttable ${1}
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700197}
198
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200199# Delete output files in case of error
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200200cleanup()
201{
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700202 rm -f .btf.*
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200203 rm -f System.map
204 rm -f vmlinux
Rasmus Villemoes5cc12472021-03-05 10:27:07 +0100205 rm -f vmlinux.map
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200206}
207
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200208# Use "make V=1" to debug this script
209case "${KBUILD_VERBOSE}" in
210*1*)
211 set -x
212 ;;
213esac
214
215if [ "$1" = "clean" ]; then
216 cleanup
217 exit 0
218fi
219
Masahiro Yamada2df8220c2022-08-28 11:39:53 +0900220${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init init/version-timestamp.o
221
Andrii Nakryiko7fd78562019-08-13 11:54:42 -0700222btf_vmlinux_bin_o=""
Masahiro Yamada7d153692021-12-14 11:53:52 +0900223if is_enabled CONFIG_DEBUG_INFO_BTF; then
Kees Cookaf73d782020-03-03 18:18:34 -0800224 btf_vmlinux_bin_o=.btf.vmlinux.bin.o
225 if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then
Stanislav Fomichevda5fb182019-11-27 08:14:10 -0800226 echo >&2 "Failed to generate BTF for vmlinux"
227 echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
228 exit 1
Andrii Nakryiko341dfcf2019-08-12 11:39:47 -0700229 fi
230fi
231
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200232kallsymso=""
Kees Cook8959e392019-08-13 08:15:32 -0700233kallsymso_prev=""
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200234kallsyms_vmlinux=""
Masahiro Yamada7d153692021-12-14 11:53:52 +0900235if is_enabled CONFIG_KALLSYMS; then
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200236
237 # kallsyms support
238 # Generate section listing all symbols and add it into vmlinux
239 # It's a three step process:
Hui Su2216cf62021-10-08 19:24:38 +0800240 # 1) Link .tmp_vmlinux.kallsyms1 so it has all symbols and sections,
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200241 # but __kallsyms is empty.
242 # Running kallsyms on that gives us .tmp_kallsyms1.o with
243 # the right size
Hui Su2216cf62021-10-08 19:24:38 +0800244 # 2) Link .tmp_vmlinux.kallsyms2 so it now has a __kallsyms section of
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200245 # the right size, but due to the added section, some
246 # addresses have shifted.
Hui Su2216cf62021-10-08 19:24:38 +0800247 # From here, we generate a correct .tmp_vmlinux.kallsyms2.o
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100248 # 3) That link may have expanded the kernel image enough that
249 # more linker branch stubs / trampolines had to be added, which
250 # introduces new names, which further expands kallsyms. Do another
251 # pass if that is the case. In theory it's possible this results
252 # in even more stubs, but unlikely.
253 # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
254 # other bugs.
255 # 4) The correct ${kallsymso} is linked into the final vmlinux.
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200256 #
257 # a) Verify that the System.map from vmlinux matches the map from
258 # ${kallsymso}.
259
Kees Cook8959e392019-08-13 08:15:32 -0700260 kallsyms_step 1
261 kallsyms_step 2
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200262
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100263 # step 3
Kees Cook8959e392019-08-13 08:15:32 -0700264 size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
265 size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
Nicholas Piggin7e2b37c2016-11-24 03:41:37 +1100266
267 if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
Kees Cook8959e392019-08-13 08:15:32 -0700268 kallsyms_step 3
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200269 fi
270fi
271
Linus Torvaldsd7b08272019-09-20 08:36:47 -0700272vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
Andrii Nakryikoe83b9f52019-04-02 09:49:50 -0700273
Jiri Olsac9a0f3b2020-07-11 23:53:24 +0200274# fill in BTF IDs
Masahiro Yamada7d153692021-12-14 11:53:52 +0900275if is_enabled CONFIG_DEBUG_INFO_BTF && is_enabled CONFIG_BPF; then
Jiri Olsa017dab32020-09-23 20:57:34 +0200276 info BTFIDS vmlinux
277 ${RESOLVE_BTFIDS} vmlinux
Jiri Olsac9a0f3b2020-07-11 23:53:24 +0200278fi
279
Yinan Liu72b39422021-12-12 19:33:58 +0800280mksysmap vmlinux System.map
281
Masahiro Yamada7d153692021-12-14 11:53:52 +0900282if is_enabled CONFIG_BUILDTIME_TABLE_SORT; then
Shile Zhang10916702019-12-04 08:46:31 +0800283 info SORTTAB vmlinux
Shile Zhangf14bf6a2019-12-04 08:46:33 +0800284 if ! sorttable vmlinux; then
285 echo >&2 Failed to sort kernel tables
286 exit 1
287 fi
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700288fi
289
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200290# step a (see comment above)
Masahiro Yamada7d153692021-12-14 11:53:52 +0900291if is_enabled CONFIG_KALLSYMS; then
Masahiro Yamada94ff2f62022-09-26 18:02:26 +0900292 if ! cmp -s System.map ${kallsyms_vmlinux}.syms; then
Michal Marek5369f552012-07-07 23:04:40 +0200293 echo >&2 Inconsistent kallsyms data
Michal Marek367e43c2012-08-10 11:55:11 +0200294 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200295 exit 1
296 fi
297fi
Rasmus Villemoes0b956e22021-03-05 11:02:12 +0100298
299# For fixdep
300echo "vmlinux: $0" > .vmlinux.d